Index: tmp/org.txm.core/src/java/org/txm/Toolbox.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/Toolbox.java	(revision 782)
+++ tmp/org.txm.core/src/java/org/txm/Toolbox.java	(revision 783)
@@ -41,17 +41,15 @@
 import java.util.logging.Level;
 
 import org.apache.commons.lang.StringUtils;
-import org.eclipse.core.runtime.CoreException;
 import org.eclipse.core.runtime.IConfigurationElement;
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.core.runtime.ISafeRunnable;
 import org.eclipse.core.runtime.Platform;
+import org.eclipse.core.runtime.RegistryFactory;
 import org.eclipse.core.runtime.SafeRunner;
+import org.eclipse.core.runtime.preferences.IPreferencesService;
 import org.osgi.framework.Bundle;
 import org.osgi.framework.Version;
-import org.eclipse.core.runtime.preferences.DefaultScope;
-import org.eclipse.core.runtime.preferences.IPreferencesService;
-import org.eclipse.osgi.util.NLS;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.core.preferences.TBXPreferences;
 import org.txm.core.preferences.TXMPreferences;
@@ -80,6 +78,11 @@
 
 	public static Workspace workspace;
 
+	
+	/**
+	 * 
+	 * @param engine
+	 */
 	private static void addEngineManager(EnginesManager<?> engine) {
 		engines.put(engine.getEnginesType(), engine);
 	}
@@ -94,22 +97,28 @@
 	}
 
 	private static boolean fetchEngineManagers() {
-		Log.info("Fetching engine managers...");
+		Log.finest("Fetching engines managers...");
 		engines.clear();
 		//System.out.println("Contributions of "+EnginesManager.ENGINEMANAGER_EXTENSION_POINT_ID);
-		Platform.getExtensionRegistry().getExtensionPoints();
-		IConfigurationElement[] contributions = Platform.getExtensionRegistry().getConfigurationElementsFor(EnginesManager.ENGINEMANAGER_EXTENSION_POINT_ID);
+		//Platform.getExtensionRegistry().getExtensionPoints();
+		IConfigurationElement[] contributions = RegistryFactory.getRegistry().getConfigurationElementsFor(EnginesManager.ENGINES_MANAGER_EXTENSION_POINT_ID);
 		//System.out.println("contributions: "+Arrays.toString(contributions));
+		
+		Log.finest(contributions.length + " engines managers found.");
+		
 		for (int i = 0; i < contributions.length; i++) {
 			try {
-				Log.info("Registering engine manager: "+contributions[i].getName());
 				EnginesManager<?> engine = (EnginesManager<?>)contributions[i].createExecutableExtension("class"); //$NON-NLS-1$
+
+				Log.finest("Registering engines manager: " + engine);
+				
 				if (engine.fetchEngines()) {
 					//System.out.println("add engine: "+engine);
 					addEngineManager(engine);
-				} else {
-					System.out.println(""+engine+" had no engine. Aborting its installation.");
 				}
+				else {
+					System.err.println("" + engine + " had no engine. Aborting its installation.");
+				}
 			} catch(Throwable e) {
 				e.printStackTrace();
 			} 
@@ -216,18 +225,14 @@
 
 
 			Log.warning("Initializing logger");
-			String level = TXMPreferences.getString(TBXPreferences.LOG_LEVEL, TBXPreferences.PREFERENCES_NODE);
-			if (level == "") {
-				level = "OFF";
-			}
-			Log.setLevel(Level.parse(level));
-			Log.setPrintInConsole(Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.ADD_TECH_LOGS, TBXPreferences.PREFERENCES_NODE)));
+			Log.setLevel(Level.parse(TXMPreferences.getString(TBXPreferences.LOG_LEVEL, TBXPreferences.PREFERENCES_NODE)));
+			Log.setPrintInConsole(TXMPreferences.getBoolean(TBXPreferences.ADD_TECH_LOGS, TBXPreferences.PREFERENCES_NODE));
 
 			if (!TXMPreferences.getString(TBXPreferences.LOG_DIR, TBXPreferences.PREFERENCES_NODE).isEmpty()) {
-				Log.setPrintInFile(Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.LOG_IN_FILE, TBXPreferences.PREFERENCES_NODE)), new File(TXMPreferences.getString(TBXPreferences.LOG_DIR, TBXPreferences.PREFERENCES_NODE)));
+				Log.setPrintInFile(TXMPreferences.getBoolean(TBXPreferences.LOG_IN_FILE, TBXPreferences.PREFERENCES_NODE), new File(TXMPreferences.getString(TBXPreferences.LOG_DIR, TBXPreferences.PREFERENCES_NODE)));
 			}
 			else {
-				Log.setPrintInFile(Boolean.parseBoolean(TXMPreferences.getString(TBXPreferences.LOG_IN_FILE, TBXPreferences.PREFERENCES_NODE)));
+				Log.setPrintInFile(TXMPreferences.getBoolean(TBXPreferences.LOG_IN_FILE, TBXPreferences.PREFERENCES_NODE));
 			}
 
 		} catch (Exception e) {
@@ -238,33 +243,35 @@
 		try {
 			startsEngineManagers(monitor);
 		} catch (Exception e) {
-			System.out.println("Error: error during engines start: "+e.getLocalizedMessage());
+			Log.severe("Error while starting engines.");
+			e.printStackTrace();
 			initializing = false;
 			throw e;
 		}
 
-		Log.info("Toolbox states: "+TXMCoreMessages.Toolbox_22 + state); //$NON-NLS-1$
+		Log.finest("Toolbox states: " + TXMCoreMessages.Toolbox_22 + state); //$NON-NLS-1$
 
 		try {
 			if (monitor != null) {
-				monitor.subTask("Loading extensions (post-installation)...");
+				monitor.subTask("Loading plug-in post-installation extensions...");
 			}
 			pluginsPostinstallation();
 		} catch(Exception e) {
-			System.out.println("Error while post-installaing plugins: "+e.getLocalizedMessage());
+			Log.severe("Error while loading post-installaing plugins.");
+			e.printStackTrace();
 		}
 
 
 		// FIXME: persistence tests
 		if (TBXPreferences.getBoolean(TBXPreferences.AUTO_SAVE_RESULTS, TBXPreferences.PREFERENCES_NODE)) {
-			System.out.println("Toolbox.initialize(): reloading persitent results...");
+			Log.finest("Toolbox.initialize(): reloading persitent results...");
 			ArrayList<String> resultsNodesQualifiers = TXMPreferences.getResultsNodesQualifiers();
 			for (String nodeQualifier : resultsNodesQualifiers) {
 				try {
-					System.out.println("Toolbox.initialize(): loading from result node qualifier " + nodeQualifier);
-					System.out.println("Toolbox.initialize(): class =  " + TXMPreferences.getString("class", nodeQualifier));
-					System.out.println("Toolbox.initialize(): parent_uuid =  " + TXMPreferences.getString(TXMPreferences.PARENT_UUID, nodeQualifier));
-					System.out.println("Toolbox.initialize(): bundle_id =  " + TXMPreferences.getString(TXMPreferences.BUNDLE_ID, nodeQualifier));
+					Log.finest("Toolbox.initialize(): loading from result node qualifier " + nodeQualifier);
+					Log.finest("Toolbox.initialize(): class =  " + TXMPreferences.getString("class", nodeQualifier));
+					Log.finest("Toolbox.initialize(): parent_uuid =  " + TXMPreferences.getString(TXMPreferences.PARENT_UUID, nodeQualifier));
+					Log.finest("Toolbox.initialize(): bundle_id =  " + TXMPreferences.getString(TXMPreferences.BUNDLE_ID, nodeQualifier));
 					Bundle bundle = Platform.getBundle(TXMPreferences.getString(TXMPreferences.BUNDLE_ID, nodeQualifier));
 					Class<?> cl = bundle.loadClass(TXMPreferences.getString("class", nodeQualifier));
 					Constructor<?> cons = cl.getConstructor(String.class);
@@ -386,7 +393,8 @@
 					SafeRunner.run(runnable);
 				}
 			} catch (Exception ex) {
-				System.out.println("Exception while installing " + e.getName() + ": " + ex.getMessage());
+				Log.severe("Exception while installing " + e.getName() + ".");
+				ex.printStackTrace();
 			}
 		}
 	}
@@ -419,18 +427,22 @@
 					SafeRunner.run(runnable);
 				}
 			} catch (Exception ex) {
-				System.out.println("Exception while installing "+e.getName()+": "+ex.getMessage());
+				Log.severe("Exception while installing " + e.getName() + ".");
+				ex.printStackTrace();
 			}
 		}
 	}
 
-
+	/**
+	 * Removes an engines manager.
+	 * @param engine
+	 */
 	private static void removeEngineManager(EnginesManager<?> engine) {
 		engines.remove(engine.getClass());
 	}
 
 	/**
-	 * Restart the toolbox.
+	 * Restarts the toolbox.
 	 *
 	 * @return true, if successful
 	 * @throws Exception 
@@ -451,7 +463,8 @@
 			shutdownWorkspace();
 			startWorkspace(monitor);
 		} catch (Exception e) {
-			Log.severe("Error while restarting workspace: "+e.getLocalizedMessage());
+			Log.severe("Error while restarting workspace.");
+			e.printStackTrace();
 		}
 		return checkState();
 	}
@@ -487,7 +500,8 @@
 			//			}
 			//		}
 		} catch(Exception e) {
-			System.out.println("Error while saving preferences: "+e.getLocalizedMessage());
+			Log.severe("Error while saving preferences.");
+			e.printStackTrace();
 		}
 	}
 
@@ -500,7 +514,8 @@
 			Toolbox.workspace = null;
 			state = false;
 		} catch (Exception e) {
-			Log.severe("Error while closing workspace: "+e.getLocalizedMessage());
+			Log.severe("Error while closing workspace.");
+			e.printStackTrace();
 		}
 	}
 
@@ -508,16 +523,16 @@
 
 		fetchEngineManagers();
 
-		Log.info("Starting "+engines.keySet().size()+" engines managers...");
+		Log.info("Starting " + engines.keySet().size() + " engines managers...");
 
 		boolean result = true;
 		for (EngineType et : engines.keySet()) {
 			try {
 				EnginesManager<?> e = engines.get(et);
-				Log.info("Start engine manager: "+e.getClass());
+				Log.info("Starting engines manager: " + e.getClass());
 				result = e.startEngines(monitor) && result; // order is important
 			} catch(Exception e) {
-				System.out.println("Error while starting engine manager: "+e);
+				Log.severe("Error while starting engine manager.");
 				e.printStackTrace();
 			}
 		}
@@ -526,21 +541,21 @@
 
 	private static boolean startWorkspace(IProgressMonitor monitor) {
 		String txmhomedir = TXMPreferences.getString(TBXPreferences.USER_TXM_HOME, TBXPreferences.PREFERENCES_NODE);
-		if (txmhomedir ==null || txmhomedir.length() == 0) {
+		if (txmhomedir == null || txmhomedir.length() == 0) {
 			state = false;
 			return false;
 		}
 
-		String location = txmhomedir+"/workspaces/default.xml";
+		String location = txmhomedir + "/workspaces/default.xml";
 		
 		Version currentVersion = BundleUtils.getBundleVersion("org.txm.core");
-		Log.info("CURRENT TBX VERSION: "+currentVersion);
+		Log.info("Current toolbox version: " + currentVersion);
 		String installedVersionString = TXMPreferences.getString(TBXPreferences.VERSION, TBXPreferences.PREFERENCES_NODE);
-		if ("".equals(installedVersionString)) {
+		if (installedVersionString.isEmpty()) {
 			installedVersionString = "0.0.0";
 		}
 		Version installedVersion = new Version(installedVersionString);
-		Log.info("INSTALLED TBX VERSION: "+installedVersion);
+		Log.info("Installed toolbox version: " + installedVersion);
 		try {
 
 			//System.out.println("Toolbox.startWorkspace(): workspace location = " + location);
@@ -557,21 +572,21 @@
 
 				// test
 				if (Toolbox.workspace == null) {
-					System.out.println("Error: workspace not created (null)");
+					Log.severe("Error: workspace not created (is null).");
 					return false;
 				}
 				
 				TXMPreferences.put(TBXPreferences.PREFERENCES_NODE, TBXPreferences.VERSION, currentVersion.toString());
 			} else if (doUpdateworkspace // newer install
 					) {
-				System.out.println("Updating Toolbox workspace");
+				Log.info("Updating Toolbox workspace...");
 
 				// create or update the workspace & create TXM default.xml workspace file
 				Toolbox.workspace = Workspace.createOrUpdate(new File(txmhomedir)); //$NON-NLS-1$
 
 				// test
 				if (Toolbox.workspace == null) {
-					System.out.println("Error: workspace not created (null)");
+					Log.severe("Error: workspace not created (is null).");
 					return false;
 				}
 				
Index: tmp/org.txm.core/src/java/org/txm/EngineType.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/EngineType.java	(revision 782)
+++ tmp/org.txm.core/src/java/org/txm/EngineType.java	(revision 783)
@@ -1,5 +1,9 @@
 package org.txm;
 
 public enum EngineType {
-	SEARCH,STAT,CHART,SCRIPT,ANNOTATION;
+	SEARCH,
+	STATS,
+	CHARTS,
+	SCRIPT,
+	ANNOTATION;
 }
Index: tmp/org.txm.core/src/java/org/txm/core/preferences/TBXPreferences.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/preferences/TBXPreferences.java	(revision 782)
+++ tmp/org.txm.core/src/java/org/txm/core/preferences/TBXPreferences.java	(revision 783)
@@ -87,6 +87,8 @@
 		preferences.putBoolean(TBXPreferences.ADD_TECH_LOGS, false); //$NON-NLS-1$
 		preferences.putBoolean(TBXPreferences.LOG_STACKTRACE, true); //$NON-NLS-1$
 		preferences.putBoolean(TBXPreferences.LOG_IN_FILE, false); //$NON-NLS-1$
+		preferences.put(TBXPreferences.LOG_LEVEL, "OFF"); //$NON-NLS-1$
+		
 		preferences.put(TBXPreferences.UI_LOCALE, "fr"); //$NON-NLS-1$
 		
 		preferences.put(TBXPreferences.METADATA_ENCODING, "UTF-8"); //$NON-NLS-1$
Index: tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 782)
+++ tmp/org.txm.core/src/java/org/txm/core/results/TXMResult.java	(revision 783)
@@ -229,7 +229,7 @@
 	protected void createUUID() {
 		// FIXME: see if it's useful to put the class name or not, should be better to save it in the .prefs
 		//this.uniqueID = this.getClass().getName() + '@' + ID_TIME_FORMAT.format(new Date(System.currentTimeMillis())) + "_" + UUID.randomUUID();
-		this.uniqueID = ID_TIME_FORMAT.format(new Date(System.currentTimeMillis())) + "_" + UUID.randomUUID();
+		this.uniqueID = "txm_res_" + ID_TIME_FORMAT.format(new Date(System.currentTimeMillis())) + "_" + UUID.randomUUID();
 	}
 
 	/**
@@ -709,7 +709,7 @@
 	 */
 	public boolean autoSaveParametersFromAnnotations() throws Exception {
 
-		System.out.println("TXMResult.autoSaveParametersFromAnnotations(): saving parameters to local node...");
+		System.out.println("TXMResult.autoSaveParametersFromAnnotations(): " + this.getClass().getSimpleName() + ": saving parameters to local node...");
 
 		// internal data to save for unserialization
 		this.saveParameter("class", this.getClass().getName());
@@ -941,11 +941,27 @@
 		return false;
 	}
 
+	
 	/**
+	 * Gets a child specified by its index in the children list.
+	 * @param index
+	 * @return the child specified by its index if exists otherwise null
+	 */
+	synchronized public TXMResult getChild(int index) {
+		try {
+			return this.children.get(index);
+		}
+		catch (Exception e) {
+			return null;
+		}
+	}
+	
+	/**
 	 * Adds a child result to this result.
+	 * If the child already have a parent, the child will be remove from its old parent children.
 	 * 
 	 * @param child
-	 * @return
+	 * @return true if the child has been added
 	 */
 	synchronized public boolean addChild(TXMResult child) {
 		try {
@@ -1330,8 +1346,7 @@
 	}
 
 	/**
-	 * Gets a string representing the result and that can be used as a file
-	 * name.
+	 * Gets a string representing the result and that can be used as a file name.
 	 * 
 	 * @return
 	 */
@@ -1346,8 +1361,7 @@
 	}
 
 	/**
-	 * Gets a string representing the concatenation of the simple names of the
-	 * branch of this result.
+	 * Gets a string representing the concatenation of the simple names of the branch of this result.
 	 * 
 	 * @return
 	 */
@@ -1482,7 +1496,20 @@
 		return this.compute(monitor, true);
 	}
 
+	
 	/**
+	 * 
+	 * @param monitor
+	 * @param deepComputing
+	 * @return
+	 * @throws Exception
+	 */
+	public boolean compute(IProgressMonitor monitor, boolean deepComputing) throws Exception	{
+		return this.compute(monitor, deepComputing, true);
+	}
+	
+	
+	/**
 	 * Computes the result if 
 	 * it can be computed 
 	 * it is dirty 
@@ -1497,20 +1524,19 @@
 	 * @throws CqiClientException
 	 * @throws IOException
 	 */
-	protected boolean compute(IProgressMonitor monitor, boolean updateLastParameters) throws Exception {
+	protected boolean compute(IProgressMonitor monitor, boolean deepComputing, boolean updateLastParameters) throws Exception {
 
 		boolean skipComputing = false;
 		
 		this.monitor = monitor;
 
-		if (!this.isDirtyFromHistory()) {
+		if (!this.isDirty() && !this.isDirtyFromHistory()) {
 
 			// FIXME: Debug
 			System.err.println("TXMResult.compute(): " + this.getClass().getSimpleName() + ": result parameters have not changed since last computing, computing skipped.");
 
 			skipComputing = true;
 		}
-
 		else if (!this.isDirty()) {
 
 			// FIXME: Debug
@@ -1530,14 +1556,15 @@
 			// TODO where do we put this parent compute ? :o
 			//		if (parent != null && !parent.getHasBeenComputedOnce()) { // parent must be computed at least one time
 			// SJ: other way, test the object itself
-			if (parent != null && !parent.getHasBeenComputedOnce()) { 
-				if (!this.parent.compute(monitor)) {
-					System.err.println("TXMResult.compute(): " + this.getClass().getSimpleName() + ": failed to compute parent result, computing stopped.");
+			if (parent != null && !parent.hasBeenComputedOnce()) { 
+				if (!this.parent.compute(monitor, false, updateLastParameters)) {
+					System.err.println("TXMResult.compute(): " + this.getClass().getSimpleName() + ": failed to compute parent result.");
 	
-					return false;
+					//return false;
 				}
 			}
 	
+			// Computing requirements test
 			if (!this.canCompute()) {
 				// FIXME: Debug
 				System.err.println("TXMResult.compute(): " + this.getClass().getSimpleName() + ": missing or wrong parameters, computing aborted.");
@@ -1545,6 +1572,7 @@
 				return false;
 			}
 	
+			// Computing
 			if (!this._compute()) {
 	
 				// FIXME: Debug
@@ -1552,6 +1580,20 @@
 	
 				return false;
 			}
+			
+			// FIXME: Children cascade computing
+			if(deepComputing)	{
+				
+				// FIXME: Debug
+				System.err.println("TXMResult.compute(): " + this.getClass().getSimpleName() + ": cascade computing of " + this.children.size() + " children.");
+
+				
+				for (int i = 0; i < this.children.size(); i++) {
+					this.getChild(i).setDirty(); // force recomputing even if some parameters of the result itself have not changed
+					this.getChild(i).compute(monitor, deepComputing, updateLastParameters);
+				}
+			}
+			
 		}
 		
 		// store last used parameters
@@ -1644,7 +1686,7 @@
 	public abstract boolean toTxt(File outfile, String encoding, String colseparator, String txtseparator) throws Exception;
 
 
-	public boolean getHasBeenComputedOnce() {
+	public boolean hasBeenComputedOnce() {
 		return hasBeenComputedOnce;
 	}
 
Index: tmp/org.txm.core/src/java/org/txm/objects/BaseParameters.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/BaseParameters.java	(revision 782)
+++ tmp/org.txm.core/src/java/org/txm/objects/BaseParameters.java	(revision 783)
@@ -12,13 +12,12 @@
 import java.util.Date;
 import java.util.HashMap;
 import java.util.HashSet;
-import java.util.List;
 import java.util.Locale;
 
 import javax.xml.parsers.ParserConfigurationException;
 
-import org.txm.utils.xml.DomUtils;
 import org.txm.utils.logger.Log;
+import org.txm.utils.xml.DomUtils;
 import org.w3c.dom.Document;
 import org.w3c.dom.Element;
 import org.w3c.dom.NodeList;
Index: tmp/org.txm.core/src/java/org/txm/objects/Workspace.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Workspace.java	(revision 782)
+++ tmp/org.txm.core/src/java/org/txm/objects/Workspace.java	(revision 783)
@@ -33,11 +33,8 @@
 import java.io.IOException;
 import java.io.OutputStreamWriter;
 import java.io.Writer;
-import java.util.ArrayList;
-import java.util.Arrays;
 import java.util.Collection;
 import java.util.HashMap;
-import java.util.List;
 
 import javax.xml.parsers.DocumentBuilder;
 import javax.xml.parsers.DocumentBuilderFactory;
@@ -53,12 +50,10 @@
 import org.eclipse.core.runtime.IConfigurationElement;
 import org.eclipse.core.runtime.Platform;
 import org.eclipse.osgi.util.NLS;
-import org.txm.EnginesManager;
 import org.txm.PostTXMHOMEInstallationStep;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.core.preferences.TBXPreferences;
 import org.txm.core.preferences.TXMPreferences;
-import org.txm.utils.BundleUtils;
 import org.txm.utils.DeleteDir;
 import org.txm.utils.io.FileCopy;
 import org.txm.utils.logger.Log;
Index: tmp/org.txm.core/src/java/org/txm/objects/TxmObject.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/TxmObject.java	(revision 782)
+++ tmp/org.txm.core/src/java/org/txm/objects/TxmObject.java	(revision 783)
@@ -90,7 +90,7 @@
 	/**
 	 * @return true for now
 	 */
-	public boolean getHasBeenComputedOnce() {
+	public boolean hasBeenComputedOnce() {
 		//TODO remove this when TXMObjects will be computable
 		return true;
 	}
Index: tmp/org.txm.core/src/java/org/txm/objects/Base.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Base.java	(revision 782)
+++ tmp/org.txm.core/src/java/org/txm/objects/Base.java	(revision 783)
@@ -36,7 +36,6 @@
 import java.io.Writer;
 import java.util.ArrayList;
 import java.util.HashMap;
-import java.util.List;
 
 import javax.xml.transform.OutputKeys;
 import javax.xml.transform.Result;
@@ -46,10 +45,8 @@
 import javax.xml.transform.dom.DOMSource;
 import javax.xml.transform.stream.StreamResult;
 
-import org.osgi.service.prefs.BackingStoreException;
-import org.txm.Toolbox;
-import org.txm.core.messages.TXMCoreMessages;
 import org.eclipse.core.runtime.IProgressMonitor;
+import org.txm.core.messages.TXMCoreMessages;
 import org.txm.utils.logger.Log;
 import org.txm.utils.zip.Zip;
 import org.w3c.dom.Document;
Index: tmp/org.txm.core/src/java/org/txm/objects/Alignement.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Alignement.java	(revision 782)
+++ tmp/org.txm.core/src/java/org/txm/objects/Alignement.java	(revision 783)
@@ -1,6 +1,5 @@
 package org.txm.objects;
 
-import org.txm.core.results.TXMParameters;
 
 
 /**
Index: tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/editors/TextsBalanceEditor.java
===================================================================
--- tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/editors/TextsBalanceEditor.java	(revision 782)
+++ tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/editors/TextsBalanceEditor.java	(revision 783)
@@ -62,7 +62,7 @@
 
 		
 		// for group tests
-		Composite parametersArea = this.getCommandParametersGroup();
+		Composite parametersArea = this.getExtendedParametersComposite();
 		
 		Group group = new Group(parametersArea, SWT.NONE);
 		
Index: tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/editors/ReferencerEditor.java
===================================================================
--- tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/editors/ReferencerEditor.java	(revision 782)
+++ tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/editors/ReferencerEditor.java	(revision 783)
@@ -151,22 +151,22 @@
 
 		
 		parent.setLayout(new GridLayout(1,true));
-		Composite paramArea = getCommandParametersGroup();
+		Composite paramArea = getExtendedParametersComposite();
 		paramArea.setLayout(new GridLayout(3, false));
 		
-		getMinimalParametersComposite().getLayout().numColumns = 3;
-		getMinimalParametersComposite().setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, false));
+		getMainParametersComposite().getLayout().numColumns = 3;
+		getMainParametersComposite().setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, false));
 		
-		Label queryLabel = new Label(getMinimalParametersComposite(), SWT.NONE);
+		Label queryLabel = new Label(getMainParametersComposite(), SWT.NONE);
 		queryLabel.setText(TXMUIMessages.CreateSubcorpusDialog_10);
 		queryLabel.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false));
 		
-		querywidget = new QueryWidget(getMinimalParametersComposite(), SWT.None);
+		querywidget = new QueryWidget(getMainParametersComposite(), SWT.None);
 		querywidget.setLayoutData(new GridData(GridData.FILL, GridData.CENTER, true, false));
 		querywidget.addKeyListener(computeKeyListener);
 
 		// [Edit]
-		propertiesSelector = new PropertiesSelector<Property>(getMinimalParametersComposite(), SWT.NONE);
+		propertiesSelector = new PropertiesSelector<Property>(getMainParametersComposite(), SWT.NONE);
 		propertiesSelector.setMaxPropertyNumber(1);
 		propertiesSelector.setLayoutData(new GridData(GridData.FILL, GridData.FILL,
 				false, false));
Index: tmp/org.txm.specificities.rcp/src/org/txm/specificities/rcp/editors/SpecificitiesEditor.java
===================================================================
--- tmp/org.txm.specificities.rcp/src/org/txm/specificities/rcp/editors/SpecificitiesEditor.java	(revision 782)
+++ tmp/org.txm.specificities.rcp/src/org/txm/specificities/rcp/editors/SpecificitiesEditor.java	(revision 783)
@@ -102,21 +102,23 @@
 
 		try {
 
+			// Main parameters
+			GLComposite mainParametersArea = this.getMainParametersComposite();
+			mainParametersArea.getLayout().numColumns = 2;
 			
 			// unit property
-			GLComposite minimalParametersArea = this.getMinimalParametersComposite();
-			minimalParametersArea.getLayout().numColumns = 2;
-
-			new Label(minimalParametersArea, SWT.NONE).setText(TXMCoreMessages.common_property);
-			this.unitPropertyComboViewer = new PropertiesComboViewer(minimalParametersArea, this, true,
+			new Label(mainParametersArea, SWT.NONE).setText(TXMCoreMessages.common_property);
+			this.unitPropertyComboViewer = new PropertiesComboViewer(mainParametersArea, this, true,
 					Corpus.getFirstParentCorpus(this.getResult()).getOrderedProperties(),
 					this.getResult().getUnitProperty(), true);
 
 			
+			// Extended parameters
+			Composite extendedParametersArea = this.getExtendedParametersComposite();
+			
 			// max score
-			Composite parametersArea = this.getCommandParametersGroup();
-			new Label(parametersArea, SWT.NONE).setText("Maximum score");
-			this.maxScore = new Spinner(parametersArea, SWT.BORDER);
+			new Label(extendedParametersArea, SWT.NONE).setText("Maximum score");
+			this.maxScore = new Spinner(extendedParametersArea, SWT.BORDER);
 			this.maxScore.setToolTipText("The maximum score to display");
 			this.maxScore.setMinimum(0);
 
@@ -156,7 +158,7 @@
 			specificitesTable = viewer.getTable();
 			specificitesTable.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 2));
 
-			// create 1st column
+			// create 1st column: Unit
 			TableColumn typeNameColumn = new TableColumn(specificitesTable, SWT.NONE);
 			typeNameColumn.setText(TXMCoreMessages.common_units);
 			typeNameColumn.setToolTipText(TXMCoreMessages.common_units);
@@ -166,12 +168,15 @@
 			viewerComparator.addSelectionAdapter(viewer, typeNameColumn, 0);
 			
 			
-			// create 2nd column
+			// create 2nd column: Frequency
 			this.typeFrequencyColumn = new TableColumn(viewer.getTable(), SWT.NONE);
+			this.typeFrequencyColumn.setAlignment(SWT.RIGHT);
+			this.typeFrequencyColumn.setText(TXMCoreMessages.common_frequency);
+			
 			viewerComparator.addSelectionAdapter(viewer, typeFrequencyColumn, 1);
 			
 			
-			// add a separator column
+			// add a separator empty column
 			TableColumn separatorColumn = new TableColumn(specificitesTable, SWT.NONE);
 			separatorColumn.setResizable(false);
 
@@ -205,22 +210,20 @@
 	@Override
 	public void updateEditorFromResult(boolean update) {
 		try {
+
+			
 			if(!update)	{
-				typeFrequencyColumn.setText(TXMCoreMessages.common_frequency + " " + SpecificitiesUIMessages.SpecificitiesTableEditor_11 + " " + this.getResult().getCorpusSize()); //$NON-NLS-1$ //$NON-NLS-2$
-				typeFrequencyColumn.setToolTipText(typeFrequencyColumn.getText()); 
-				typeFrequencyColumn.setAlignment(SWT.RIGHT);
-				typeFrequencyColumn.pack();
-				
 				String[] partNames = null;
 				int[] partSize = null;
 				try {
 					partNames = this.getResult().getPartShortNames();
 					partSize = this.getResult().getPartSizes();
-				} catch (StatException e) {
+				} catch (Exception e) {
 					System.err.println(NLS.bind(RCoreMessages.error_unexpectedErrorInRStatisticsEngine, e));
 					Log.printStackTrace(e);
 					return;
 				}
+
 				// System.out.println("partnames: "+Arrays.toString(partNames));
 				for (int i = 0, columnIndex = 2; i < partNames.length ; i++) { // for each part
 
@@ -248,27 +251,36 @@
 			}
 
 			
-			// units
-			String[] typeNames = this.getResult().getTypeNames();
-			// units' total freq
-			int[] typeFreq = this.getResult().getFormFrequencies();
-			// units' index fr each part
-			double[][] specIndex = this.getResult().getSpecificitesIndex();
-			int[][] specFreqs = this.getResult().getFrequency();
+
 			
-			// units' total in parts
-			//final int[] sortedPartIndexes = specificitesResult.getSortedPartIndexes();
+			if(this.getResult().canCompute())	{
+				
+				typeFrequencyColumn.setText(TXMCoreMessages.common_frequency + " " + SpecificitiesUIMessages.SpecificitiesTableEditor_11 + " " + this.getResult().getCorpusSize()); //$NON-NLS-1$ //$NON-NLS-2$
+				typeFrequencyColumn.setToolTipText(typeFrequencyColumn.getText()); 
+				typeFrequencyColumn.pack();
 
-			// Create an array of lines to fill the tables
-			//		System.out.println("len types: "+typeNames.length);
-			//		System.out.println("len freq: "+typeFreq.length);
-			//		System.out.println("len spec: "+specFreqs.length);
-			//		System.out.println("len specidx: "+specIndex.length);
-			 Object[] tableLines = new Object[typeNames.length];
-			for (int j = 0; j < tableLines.length; j++) {
-				tableLines[j] = new Object[] { typeNames[j], new Integer(typeFreq[j]), specFreqs[j], specIndex[j] };
+				// units
+				String[] typeNames = this.getResult().getTypeNames();
+				// units' total freq
+				int[] typeFreq = this.getResult().getFormFrequencies();
+				// units' index fr each part
+				double[][] specIndex = this.getResult().getSpecificitesIndex();
+				int[][] specFreqs = this.getResult().getFrequency();
+				
+				// units' total in parts
+				//final int[] sortedPartIndexes = specificitesResult.getSortedPartIndexes();
+	
+				// Create an array of lines to fill the tables
+				//		System.out.println("len types: "+typeNames.length);
+				//		System.out.println("len freq: "+typeFreq.length);
+				//		System.out.println("len spec: "+specFreqs.length);
+				//		System.out.println("len specidx: "+specIndex.length);
+				 Object[] tableLines = new Object[typeNames.length];
+				for (int j = 0; j < tableLines.length; j++) {
+					tableLines[j] = new Object[] { typeNames[j], new Integer(typeFreq[j]), specFreqs[j], specIndex[j] };
+				}
+				viewer.setInput(tableLines);
 			}
-			viewer.setInput(tableLines);
 
 			// Pack the columns so the label of the sort column is not truncated due of the sorting order arrow display			
 			TXMEditor.packColumns(viewer);
Index: tmp/org.txm.specificities.rcp/src/org/txm/specificities/rcp/editors/SpecificitiesSelectionEditor.java
===================================================================
--- tmp/org.txm.specificities.rcp/src/org/txm/specificities/rcp/editors/SpecificitiesSelectionEditor.java	(revision 782)
+++ tmp/org.txm.specificities.rcp/src/org/txm/specificities/rcp/editors/SpecificitiesSelectionEditor.java	(revision 783)
@@ -47,10 +47,10 @@
 		
 		
 		// Banality
-        Label label = new Label(this.getCommandParametersGroup(), SWT.NONE);
+        Label label = new Label(this.getExtendedParametersComposite(), SWT.NONE);
         label.setText("Banality:");
 		
-		banality = new FloatSpinner(this.getCommandParametersGroup(), SWT.BORDER);
+		banality = new FloatSpinner(this.getExtendedParametersComposite(), SWT.BORDER);
 		banality.setToolTipText("Banality threshold");
 		banality.setMaximumAsFloat(2);
 		banality.addSelectionListener(new ComputeSelectionListener(this));
